<?php

  $requiredFields = array('name', 'email', 'subject', 'message');
  $errors = array();
  $hasErrors = false;
  for($i=0; $i<count($requiredFields); $i++) {
    $key   = $requiredFields[$i];
    $hasErrorForField = false;
    if(!isset($_POST[$key]) || $_POST[$key] == "") {
      $hasErrorForField = true;
    }
    if($key == 'email') {
      $emailRegex = '/^(([^<>()[\]\\.,;:\s@\"]+(\.[^<>()[\]\\.,;:\s@\"]+)*)|(\".+\"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/';
      if(!preg_match($emailRegex,$_POST[$key])) {
        $hasErrorForField = true;
      }
    }
    if($hasErrorForField) {
      array_push($errors, $key);
      $hasErrors = true;
    }
  }
  
  if($hasErrors) {
    header('HTTP/1.0 400 Bad Request', true, 400);
    echo json_encode(array("status"=>400, "errors"=>$errors));
  } else {

    function clean_string($string) {
      $bad = array("content-type","bcc:","to:","cc:","href");
      return str_replace($bad,"",$string);
    }
    $headers = 'From: '.clean_string($_POST['name']).'<'.clean_string($_POST['email']).'>';
    $result = mail("pbergstr@gmail.com", ("[PB.com] ".clean_string($_POST['subject'])), clean_string($_POST['message']), $headers);
    
    if(!$result) {
      header('HTTP/1.0 500 Internal Server Error', true, 500);
      echo json_encode(array("status"=>500));
      
    } else {
      header('HTTP/1.0 200 OK', true, 200);
    }
  }
?>
